<script setup lang="ts">
import { ref } from "vue";
import type { Ref } from "vue";
import type { ImageUpload } from "@/models/image";
import { useGallery } from "@/stores/gallery";
import BaseModal from "@/components/BaseModal.vue";
import UploadForm from "@/components/UploadForm.vue";
import UploadWaiting from "@/components/UploadWaiting.vue";
import UploadError from "@/components/UploadError.vue";
import UploadSuccess from "@/components/UploadSuccess.vue";

const emit = defineEmits<{
  (e: "finish"): void;
}>();

const galleryStore = useGallery();

const uploadRetry: Ref<ImageUpload | undefined> = ref(undefined);

function handleRetry() {
  if (!galleryStore.uploadPayload) {
    return emit("finish");
  }

  galleryStore.prepareUploadRetry();
}

function handleSubmit(formData: ImageUpload) {
  galleryStore.uploadImage(formData);
}

function handleReset() {
  galleryStore.resetUpload();
  emit("finish");
}
</script>

<template>
  <article class="uploader">
    <BaseModal
      v-if="
        galleryStore.uploadStatus === 'none' ||
        galleryStore.uploadStatus === 'retry'
      "
      @close-modal="handleReset"
    >
      <UploadForm
        :prefilledUpload="
          galleryStore.uploadStatus === 'retry'
            ? galleryStore.uploadPayload
            : uploadRetry
        "
        @submit="handleSubmit"
        @finish="handleReset"
      />
    </BaseModal>

    <BaseModal
      v-else-if="galleryStore.uploadStatus === 'uploading'"
      @close-modal="handleReset"
    >
      <UploadWaiting />
    </BaseModal>

    <BaseModal
      v-else-if="galleryStore.uploadStatus === 'error'"
      @close-modal="handleReset"
    >
      <UploadError @retry="handleRetry" @finish="handleReset" />
    </BaseModal>

    <BaseModal v-else @close-modal="handleReset">
      <UploadSuccess @finish="handleReset" />
    </BaseModal>
  </article>
</template>
